% Example 4: Shortest Distance of Two Ellipses, p. 378f

addpath /Applications/SeDuMi_1_1

F1 = [1 0; 0 4]; P1 = sqrtm(F1);
F2 = [5/2 3/2; 3/2 5/2]; P2 = sqrtm(F2);
g1 = [-1; 0]; g2 = [-11; -13];
c0 = [0; 0]; c1 = P1 \ g1; c2 = P2 \ g2;
gamma1 = -3; gamma2 = 70; d0 = 0;
d1 = sqrt(c1'*c1-gamma1); d2 = sqrt(c2'*c2-gamma2);
A0 = [zeros(2,1) eye(2) -eye(2)]';
A1 = [zeros(2,1) P1 zeros(2,2)]';
A2 = [zeros(2,1) zeros(2,2) P2]';
b0 = [1 0 0 0 0]'; b1 = zeros(5,1); b2 = b1;
At0 = -[b0 A0]; At1 = -[b1 A1]; At2 = -[b2 A2];
At = [At0 At1 At2];
bt = [-1 0 0 0 0]';
ct0 = [d0; c0]; ct1 = [d1; c1]; ct2 = [d2; c2];
ct = [ct0; ct1; ct2];
K = []; K.q = [size(At0,2) size(At1,2) size(At2,2)];
[xs,ys,info] = sedumi(At,bt,ct,K);
x = ys;
D = x(1) % Distance: D = norm(u-v,2)
u = [x(2:3)]'
v = [x(4:5)]'

% Displaying results
d = v-u; n = [d(2);-d(1)];
G1 = @(t) [u(1)+t*n(1);u(2)+t*n(2)]; 
G2 = @(t) [v(1)+t*n(1);v(2)+t*n(2)];
G3 = @(t) [u(1)+t*d(1);u(2)+t*d(2)];
T = linspace(-2,2,200); F1 = G1(T); F2 = G2(T);
T = linspace(0,1,200); F3 = G3(T);
FF1 = plot(F1(1,:),F1(2,:),'k-'); hold on;
FF2 = plot(F2(1,:),F2(2,:),'k-'); hold on;
FF3 = plot(F3(1,:),F3(2,:),'b-'); hold on;
nopts = 1000; phi = linspace(0,2*pi,nopts);
ell1 = inv(P1)*(d1*[cos(phi); sin(phi)] - repmat(c1,1,nopts));
ell2 = inv(P2)*(d2*[cos(phi); sin(phi)] - repmat(c2,1,nopts));
graph = plot(u(1),u(2),'o',v(1),v(2),'o', ell1(1,:), ell1(2,:),'-', ell2(1,:), ell2(2,:),'-');
set(graph(2),'MarkerFaceColor',[0 0.5 0]);
set(gca,'XTick',[]); set(gca,'YTick',[]);
axis equal
title('Shortest Distance of two Ellipses');



