% Example 5, p. 19f

% Script Penalty.m: Test of Penalty Method
clc; clear all; close all; N = 200;
X = linspace(-2,2,N); Y = X; T = linspace(0,2*pi,N);
[X,Y] = ndgrid(X,Y); Z = X.*Y.^2; 
xx = sqrt(2).*cos(T); yy = sqrt(2).*sin(T);
x1 = -sqrt(2/3); y1 = sqrt(4/3);
f = @(x) x(1)*x(2)^2; h = @(x) x(1)^2+x(2)^2-2;
x = [2, 1]; % starting value of fminsearch
for lambda = [1, 3, 6, 9]
   Phi =Z+lambda/2*(X.^2+Y.^2-2).^2;
   phi = @(x) f(x)+lambda/2*h(x)^2;
   [x,fval] =fminsearch(phi,x)
   % In the second iteration (lambda=3) fminsearch uses the result of
   % the first iteration (i.e. lambda=1) as starting value, and so on.
   figure, clf
   subplot(2,1,1);
   contour(X,Y,Z,40); colorbar;
   hold on
   P = plot(xx,yy,'k'); set(P,'linewidth',2);
   PP = plot([sqrt(2),x1,x1],[0,y1,-y1],'ko');
   set(PP,'markersize',6,'markerfacecolor','k');
   axis([-2 2 -2 2]), axis equal, axis([-2 2 -2 2]), ylabel('y')
   title(['\lambda =', num2str(lambda)]);
   subplot(2,1,2);
   contour(X,Y,Phi,160); colorbar;
   hold on
   P = plot(xx,yy,'k'); set(P,'linewidth',2);
   PP = plot([sqrt(2),x1,x1],[0,y1,-y1],'ko');
   set(PP,'markersize',6,'markerfacecolor','k');
   % Plot the minimum of phi
   PP = plot(x(1),x(2),'r+');
   set(PP,'markersize',6,'linewidth',3);
   axis([-2 2 -2 2]), axis equal, axis([-2 2 -2 2])
   xlabel('x'), ylabel('y')
   waitforbuttonpress % to wait for a click on a figure
end

