format long;
[X,y] = LoadData;
m = 120; n = size(X,2);
w0 = zeros(n,1);

global X_train y_train lambda; 
X_train = X(1:m,:); y_train = y(1:m); 


for lambda = [0, 1, 2]

disp(' ');disp(' ');disp('lambda');disp(lambda);disp(' ');disp(' ');


disp(' '); disp(' '); disp('NEWTON'); disp(' ');
Tol = 1e-7;
[w,iterations] = LogReg(w0,Tol)

yp = sign(X_train*w);
z = (yp .* y_train > 0);
accuracy_train = sum(z)/m
X_test = X(m+1:end,:);
y_test = y(m+1:end);
[M,N] = size(X_test);
yp = sign(X_test*w);
P = (yp .* y_test > 0);
accuracy_test = sum(P)/M
PM = (X_test*w > 0 & y_test > 0); disp('sum(PM) = '), disp(sum(PM))
NM = (X_test*w < 0 & y_test > 0); disp('sum(NM) = '), disp(sum(NM))
sensitivity = sum(PM)/(sum(PM)+sum(NM))
PB = (X_test*w > 0 & y_test < 0); disp('sum(PB) = '), disp(sum(PB))
NB = (X_test*w < 0 & y_test < 0); disp('sum(NB) = '), disp(sum(NB))
specificity = sum(NB)/(sum(PB)+sum(NB))

[f,g,H] = ObjFun(w)
disp('condition of H: '), disp(cond(H))

tic;
for i = 1:100
  clear functions;
  [w,iterations] = LogReg(zeros(n,1),Tol);
end
disp('CPU Time of 100 Cycles:'); toc;



disp(' '); disp(' '); disp('NELDER-MEAD METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7,'MaxIter',8000,'MaxFunEvals',20000);
[w,fval,exitflag,output] = fminsearch(@ObjFun,w0,options)

tic; 
for i = 1:10
  clear functions;
  [w,fval,exitflag,output] = fminsearch(@ObjFun,w0,options);
end
disp('CPU Time of 10 Cycles:'); toc;



disp(' '); disp(' '); disp('STEEPEST DESCENT METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','steepdesc','OutputFcn',@outfun,...
    'MaxIter',30000,'MaxFunEvals',120000);
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

tic;
options = optimset('Display','off','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','steepdesc',...
    'MaxIter',30000,'MaxFunEvals',120000);
for i = 1:10
  clear functions;
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
disp('CPU Time of 10 Cycles:'); toc;




disp(' '); disp(' '); disp('(SUBSPACE) TRUST REGION METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7,'GradObj','on','Hessian','on','OutputFcn',@outfun);
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

tic;
options = optimset('Display','off','TolX',1e-7,'TolFun',1e-7,'GradObj','on','Hessian','on');
for i = 1:100
  clear functions;
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
disp('CPU Time of 100 Cycles:'); toc;



disp(' '); disp(' '); disp('DFP METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','dfp','OutputFcn',@outfun,...
    'MaxIter',11000,'MaxFunEvals',15000);
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

tic;
options = optimset('Display','off','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','dfp',...
    'MaxIter',11000,'MaxFunEvals',15000);
for i = 1:10
  clear functions;
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
disp('CPU Time of 10 Cycles:'); toc;




disp(' '); disp(' '); disp('BFGS METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','bfgs','OutputFcn',@outfun);
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

tic;
options = optimset('Display','off','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','bfgs');
for i = 1:100
  clear functions;
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
disp('CPU Time of 100 Cycles:'); toc;



end


