format long
global X y lambda;
[X,y] = LoadData;
[m,n] = size(X);
w0 = zeros(n,1);


for lambda = [0, 1, 2]

disp(' ');disp(' ');disp('lambda');disp(lambda);disp(' ');disp(' ');


disp(' '); disp(' '); disp('NELDER-MEAD METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7);
[w,fval,exitflag,output] = fminsearch(@ObjFun,w0,options)

[f,g,H] = ObjFun(w)
disp('condition of H:'), disp(cond(H))

disp('CPU Time of 100 Cycles:')
tic; options = optimset('Display','off','TolX',1e-7,'TolFun',1e-7);
for i = 1:100
  clear functions;
  [w,fval,exitflag,output] = fminsearch(@ObjFun,w0,options);
end
toc;


disp(' '); disp(' '); disp('STEEPEST DESCENT METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','steepdesc','OutputFcn',@outfun,...
    'MaxIter',1000,'MaxFunEvals',4000);
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

disp('CPU Time of 100 Cycles:'); tic;
options = optimset('Display','off','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','steepdesc',...
    'MaxIter',1000,'MaxFunEvals',4000);
for i = 1:100
  clear functions;
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
toc;



disp(' '); disp(' '); disp('(SUBSPACE) TRUST REGION METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'GradObj','on','Hessian','on','LargeScale','on','TolFun',1e-7,'OutputFcn',@outfun);
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

disp('CPU Time of 100 Cycles:'); tic;
options = optimset('Display','off','TolX',1e-7,'GradObj','on','Hessian','on','LargeScale','on','TolFun',1e-7);
for i = 1:100
  clear functions;
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
toc;


disp(' '); disp(' '); disp('NEWTON'); disp(' ');
Tol = 1e-7;
[w,iterations] = LogReg(w0,Tol)


disp('CPU Time of 100 Cycles:'); tic;
for i = 1:100
  clear functions;
  [w,iterations] = LogReg(w0,Tol);
end
toc;


disp(' '); disp(' '); disp('DFP METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','dfp','TolFun',1e-10,...
    'OutputFcn',@outfun,'MaxIter',1000,'MaxFunEvals',3000);
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

disp('CPU Time of 100 Cycles:'); tic;
options = optimset('Display','off','TolX',1e-7,'TolFun',1e-7,'GradObj','on','LargeScale','off','HessUpdate','dfp','TolFun',1e-10,...
    'MaxIter',1000,'MaxFunEvals',3000);
for i = 1:100
  clear functions;  
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
toc;



disp(' '); disp(' '); disp('BFGS METHOD'); disp(' ');
options = optimset('Display','final','TolX',1e-7,'GradObj','on','LargeScale','off','HessUpdate','bfgs','TolFun',1e-7,'OutputFcn',@outfun); 
[w,fval,exitflag,output] = fminunc(@ObjFun,w0,options)

disp('CPU Time of 100 Cycles:'); tic;
options = optimset('Display','off','TolX',1e-7,'GradObj','on','LargeScale','off','HessUpdate','bfgs','TolFun',1e-7);
for i = 1:100
  clear functions;
  [w,fval,exitflag,output] = fminunc(@ObjFun,w0,options);
end
toc;


end
