% Powell's Test Example (cf. Exercise 2.15)

x0 = [3 0 2 -3/2 3/2 5 0];
f = @(x) 1/2*x(1)*x(3);

options = optimset('Display','iter','LargeScale','off','OutputFcn',@outfun);
x = fmincon(f,x0,[],[],[],[],[],[],@con,options)
iteration
N = size(iteration,1);
psi = linspace(0,2*pi,200);

for k = 1:N
    clf, hold on, axis equal
    xx = iteration(k,:);
    patch([xx(1),xx(2),0],[0,xx(3),0 ],'y');
    plot(xx(4)+cos(psi),xx(5)+sin(psi),'-');
    plot(xx(6)+cos(psi),xx(7)+sin(psi),'-');
    hold off, waitforbuttonpress
end
